/*
 * Licensed Materials - Property of HCL
 * UrbanCode Deploy
 * (c) Copyright HCL Technologies Ltd. 2018. All Rights Reserved.
 */
import com.urbancode.air.AirPluginTool
import com.urbancode.air.ExitCodeException
import com.urbancode.air.plugin.ispw.versions.SetClient
import org.apache.log4j.Level
import org.apache.log4j.Logger

AirPluginTool apTool = new AirPluginTool(this.args[0], this.args[1])
Properties props = apTool.getStepProperties()

String logLevel = props['loggerLevel']
Logger.getRootLogger().setLevel(Level.toLevel(logLevel))
Logger logger = Logger.getLogger(getClass())

String setId = props['setId'].trim()
String action = props['action']

SetClient setClient = new SetClient(props)
Map<String, String> responseMap

try {
    logger.info("Performing ${action} action on set with ID ${setId}.")
    responseMap = setClient.performAction(setId, action)
    logger.info("Successfully performed action on set.")
}
/* Catch custom thrown exceptions */
catch (ExitCodeException ex) {
    logger.error(ex)    // Log error message and ignore stack trace
    System.exit(1)
}

if (responseMap != null && !responseMap.isEmpty()) {
    if (responseMap.containsKey("setId")) {
        apTool.setOutputProperty("setId", responseMap.id)
    }
    if (responseMap.containsKey("url")) {
        apTool.setOutputProperty("url", responseMap.url)
    }

    apTool.storeOutputProperties()
}
