/*
 * Licensed Materials - Property of HCL
 * UrbanCode Deploy
 * (c) Copyright HCL Technologies Ltd. 2018. All Rights Reserved.
 */
import com.urbancode.air.AirPluginTool
import com.urbancode.air.ExitCodeException
import com.urbancode.air.plugin.ispw.versions.ReleaseClient

import org.apache.log4j.Level
import org.apache.log4j.Logger

AirPluginTool apTool = new AirPluginTool(this.args[0], this.args[1])
Properties props = apTool.getStepProperties()

String logLevel = props['loggerLevel']
Logger.getRootLogger().setLevel(Level.toLevel(logLevel))
Logger logger = Logger.getLogger(getClass())

String releaseId = props['releaseId'].trim()
String level = props['level'].trim()

ReleaseClient releaseClient = new ReleaseClient(props)
Map<String, String> responseMap

try {
    logger.info("Promoting release with ID ${releaseId}.")
    responseMap = releaseClient.promote(releaseId, level)
    logger.info("Successfully promoted release.")
}
/* Catch custom thrown exceptions */
catch (ExitCodeException ex) {
    logger.error(ex)    // Log error message and ignore stack trace
    System.exit(1)
}

if (responseMap != null && !responseMap.isEmpty()) {
    if (responseMap.containsKey("setId")) {
        apTool.setOutputProperty("setId", responseMap.id)
    }
    if (responseMap.containsKey("url")) {
        apTool.setOutputProperty("url", responseMap.url)
    }

    apTool.storeOutputProperties()
}
